export class DrawerAggregator {
  constructor(drawer, geometricObject, konvaObject, elementClass) {
    this.drawer = drawer;
    this.genericObject = geometricObject;
    this.konvaObject = konvaObject;
    this.aggregators = [];
    if (elementClass != undefined) this.elementClass = elementClass;
    else {
      if (
        konvaObject.attrs != undefined &&
        konvaObject.attrs.class != undefined
      )
        this.elementClass = konvaObject.attrs.class;
    }
  }
  setGeometricObject(genericObject) {
    this.genericObject = genericObject;
  }
  setDrawer(drawer) {
    this.drawer = drawer;
  }
  setKonvaObject(konvaObject) {
    this.konvaObject = konvaObject;
  }
  setElementClass(elementClass) {
    this.elementClass = elementClass;
  }
  addAggregator(aggregator) {
    if (!this.aggregators.includes(aggregator)) {
      this.aggregators.push(aggregator);
    }
  }
  update(e) {
    this.drawer.updatePositions(this, e);
    this.aggregators.forEach(aggregator => {
      aggregator.drawer.update(aggregator);
    });
    // this.drawer.update();
  }
}
